
;; Account for variations in function names.
(cond
    ((fboundp 'cheapest_paths) nil)
    ((fboundp 'cheapest_path)
	(defun cheapest_paths (a b) (cheapest_path a b))))

;; Print each (sorted) output
(defun show (&rest l)
    (showhelper l)
    )

(defun showhelper (l)
    (if (not (null l))
	(let ((*print-pretty* nil))
	    (format t "~a~&" (fixresult (car l)))
	    (showhelper (cdr l)))))


;; "Fix up" result output from project -- sort edges, etc.
(defun fixresult (r)
    (sort (flipedges r) #'cmpgraph))


;; Flip edges if necessary.
(defun flipedges (r)
    (cond
	((null r) nil)
	((atom (car r)) (cons (car r) (flipedges (cdr r))))
	(t
	    (cons
		(if (symcmp (caar r) (cadar r))
		    (car r)
		    (list (cadar r) (caar r) (caddar r)))
		(flipedges (cdr r))))))


;; Output graph comparator
(defun cmpgraph (a b)
    (cond

	;; This shouldn't happen -- but who knows what people code?
	((and (atom a) (atom b)) (< a b))

	;; Atoms (sum of path costs) should appear at end of list.
	((atom a) nil)
	((atom b) t)

	;; First check the car's
	((symcmp (car a) (car b)) t)
	((symcmp (car b) (car a)) nil)

	;; Now the cadr's
	((symcmp (cadr a) (cadr b)) t)
	((symcmp (cadr b) (cadr a)) nil)

	;; This shouldn't happen.
	(t (< (caddr a) (caddr b)))))


;; Comparator for two symbols.
(defun symcmp (a b)
    (string< (string a) (string b)))

